require 'tk'

# Window drawing section.

root = TkRoot.new() { title "BLUE FIELD CONTOL PROGRAM" }
root.geometry('+150+140')

#
# Main frames.
#
setup_frame = TkFrame.new(root, :borderwidth=>5, :relief=>:ridge).pack(:side=>"top", :fill=>"x", :padx=>10, :pady=>10)

comp_frame = TkFrame.new(root, :borderwidth=>5, :relief=>:ridge).pack(:side=>"top", :fill=>"x", :padx=>10)

control_button_frame = TkFrame.new(root, :borderwidth=>5, :relief=>:ridge).pack(:side=>"top", :fill=>"x", :padx=>10)
output_frame = TkFrame.new(root, :borderwidth=>5, :relief=>:ridge).pack(:side=>"top", :fill=>"both", :expand=>true, :padx=>10, :pady=>10)

#
# list frames.
#
#~ list_frame1 = TkFrame.new(setup_frame).pack("side"=>"left")
list_frame2 = TkFrame.new(setup_frame).pack("side"=>"left")
list_frame3 = TkFrame.new(setup_frame).pack("side"=>"left")
list_frame4 = TkFrame.new(setup_frame).pack("side"=>"left")

#~ file_frame = TkFrame.new(list_frame1, :borderwidth=>3, :relief=>:ridge).pack("side"=>"top", "padx" =>10, "pady" =>10)
#~ file_label = TkLabel.new(file_frame, :text=>"File Name", :relief=>:sunken, :background=>"lightgrey", "font"=>"arial 10").pack(:fill=>:x)
#~ file_text = TkVariable.new
#~ file_entry = TkEntry.new(file_frame, :textvariable=>file_text, :width=>13, "font"=>"arial 10").pack()

#~ file_read_button = TkButton.new(file_frame, :text=>"Read File", :background=>"lightgrey", :foreground=>"blue", :width=>8, "font"=>"arial 10").pack("pady" => 5)

#~ exit_button = TkButton.new(file_frame, :width=>8, :foreground=>"red", :text=>"Exit", :background=>"lightgrey", "font"=>"arial 10").pack(:pady=>5)

box_list_frame = TkFrame.new(list_frame2, :borderwidth=>3, :relief=>:ridge).pack("side"=>"top", "padx" =>10, "pady" =>10)
box_list_label = TkLabel.new(box_list_frame, :text=>"Blue Box List", :relief=>:sunken, :background=>"lightgrey", "font"=>"arial 10").pack(:fill=>:x)

box_delete_frame = TkFrame.new(box_list_frame).pack("side"=>"bottom", "pady" => 5)
box_delete_button = TkButton.new(box_delete_frame, :text=>"Delete", :background=>"lightgrey", :foreground=>"blue", :width=>10, "font"=>"arial 10").pack()

box_list_bar_vertical = TkScrollbar.new(box_list_frame).pack("side"=>"right", "fill"=>"y")
box_list = TkListbox.new(box_list_frame, "background"=>"white", "exportselection" => 0, "width"=>10, "height"=>10, :selectmode=>"extended", "font"=>"arial 10").pack("side"=>"left")
box_list.yscrollbar(box_list_bar_vertical)

action_list_frame = TkFrame.new(list_frame4, :borderwidth=>3, :relief=>:ridge).pack("side"=>"top", "padx" =>10, "pady" =>10)
action_list_label = TkLabel.new(action_list_frame, :text=>"Blue Box Control Format", :relief=>:sunken, :background=>"lightgrey", "font"=>"arial 10").pack(:fill=>:x)

action_list_bar_vertical = TkScrollbar.new(action_list_frame).pack("side"=>"right", "fill"=>"y")
action_list = TkListbox.new(action_list_frame, :width=>55, "background"=>"white", "exportselection" => 0, "height"=>5, :selectmode=>"extended", "font"=>"arial 10").pack("side"=>"left")
action_list.yscrollbar(action_list_bar_vertical)

action_list.insert("end", "Round amounts using .round")
action_list.insert("end", "Round amounts to the nearest whole dollar (enter as 100)")
action_list.insert("end", "Round amounts to the nearest whole dollar (enter as 100.00)")
action_list.insert("end", "Show amounts as dollars and cents (enter as 99.99)")
action_list.insert("end", "Special NYS Blue Field Trailing Decimal Point")

#
# Default selection at startup.
#
action_list.selection_set(0)

generate_button = TkButton.new(control_button_frame, :text=>"Generate Code", :background=>"lightgrey", :foreground=>"blue", :width=>18, "font"=>"arial 10").pack(:side=>"left", :padx=>10, :pady=>5)

insert_code_button = TkButton.new(control_button_frame, :text=>"Insert Code", :background=>"lightgrey", :foreground=>"blue", :width=>18, "font"=>"arial 10").pack(:side=>"left", :pady=>5)

delete_code_button = TkButton.new(control_button_frame, :width=>18, :foreground=>"blue", :text=>"Delete Code", :background=>"lightgrey", "font"=>"arial 10").pack(:side=>"left", :pady=>5, :padx=>10)

output_label = TkLabel.new(output_frame, :text=>"Generated Blue Field Control Code - NOTE: ' Ctrl / ' selects all text.", :relief=>:sunken, :background=>"lightgrey", "font"=>"arial 10").pack(:fill=>:x)
out_text_bar_vert = TkScrollbar.new(output_frame).pack("side"=>"right", "fill"=>"y")
out_text = TkText.new(output_frame, "height"=>15, "font"=>"arial 10").pack("side"=>"bottom", "fill"=>"both", "expand"=>true)
out_text.yscrollbar(out_text_bar_vert)

#
# Action Section:
#

#
# ###############################################################
#
# Globals:
#
cur_dir = "C:/Users/"

box_array = Array.new
xml_box_array = Array.new

def get_file_name(dir, type)

	ftypes = case (type)
			when ("RBW"): [ ["Ruby source files", '.rbw'] ]
			when ("XML"): [ ["XML files", '.xml'] ]
		end

	Tk.getOpenFile(:filetypes=>ftypes, :initialdir=>dir)
end

def build_box_array_xml(file)
  
	#~ box_list.delete(0, box_list.index('end'))
	#~ box_array.clear

	box_array = Array.new

	File.open(file, "r") do |src_file|

		#
		# First read the file looking for target blue boxes - justifications of "right"/"decimal"/"decimal np".
		#
		while (line = src_file.gets)
			if (line =~ /(text ref=\")(box\d+_\d+)(\" justification=\")(right|decimal|decimal_no_point)\"/)
				box_array.insert(-1, $2)
			end
		end
	end




	File.open(file, "r") do |src_file|

		#
		# Now filter out those boxes that are calculated. Did not do this in the above loop because I am not sure if the
		# XML files are always structered the same way, that is, the boxes defined first, then the actual code follows.
		#
		while (line = src_file.gets)
			if (line =~ /print +'(box\d+_\d+)', +(box\d+_\d+) */)
				box_array.delete($1) if (box_array.include?($1))
			end
		end
	end

	#~ box_array.each { |x| box_list.insert("end", x) }

	#~ # Select (show highlighting) first list element.
	#~ box_list.selection_set(0)

	box_array
end

#~ exit_button.bind("Button-1") { exit(0) }

generate_button.bind("Button-1") {

	out_text.delete("1.0", "end")

	format = ""
	round = ""
	nys_format = false

	index = action_list.index("active")
	
	case index

		when 0 then round = ".round.to_s"
		when 1 then format = "'%0.0f' % "
		when 2 then format = "'%0.2f' % "
		when 3 then format = "'%0.2f' % "
		when 4
			# Special NYS Decimal expression.
			nys_format = true
	end

	if (index == 4)
		out_text.insert("end", "# Format Blue Fields Per Special NYS Decimal Point Handling\n\n")
	else
		out_text.insert("end", "# Format Blue Fields to follow CAUTION\n\n")
	end

	#
	# Generating the blue box control based upon the selected format style.
	#
	xml_box_array.each { |element|

		out_text.insert("end", "if (!#{element}.strip.empty?)\n")

		if (nys_format)
			out_text.insert("end", "\tprint '#{element}', #{element}.to_c!(0)\n")
		else
			out_text.insert("end", "\t#{element}.replace(#{format}#{element}.to_f#{round})\n")
			out_text.insert("end", "\tprint '#{element}', #{element}\n")
		end

		out_text.insert("end", "end\n")
		}

	# Set the focus to the output text window, and put the cursor at the first char on line one.
	out_text.focus
	out_text.mark_set('insert', '1.0')
}

delete_code_button.bind("Button-1") { out_text.delete("1.0", "end") }

box_delete_button.bind("Button-1") {

	#
	# Note that the box_array and the box_list are the same size, a 1:1 relationship, one mirrors the other.
	#
	box_list.curselection.each { |x|
		box_array.delete(box_list.get(x))
	}

	box_list.delete(0, box_list.index('end'))

	#
	# Update the box_list after the deletion(s).
	#
	box_array.each { |x| box_list.insert("end", x) }

	#
	# Set the highlight at the first index.
	#
	box_list.selection_set(0)
}










#
# Adding menu to this program. a work in process...................
#
#
# ###########################################################
#
# Menu:
#
#		Read:
#			Read Ruby Code file to create form box list [displaying box numbers].
#			Read XML file for box numbers [form box list] AND box truncation widths.
#
#		Profile:
#			Selection of DataFlow Profile - Individual/Entity/Fiduciary/Preparer
#
#		Exit:
#			Exit the DataFlow Code Retriever Application.
#
main_menu = TkMenu.new(root)

read_menu = TkMenu.new(main_menu, :tearoff=>false)

#
#
# This reads the .RBW file.
#
read_menu.add('command', :label=> "Ruby Source Code File", :command=> proc {

	fname = get_file_name(cur_dir, "RBW")

	unless (fname.empty?)

		cur_dir = File.dirname(fname)
		form_name = fname

		#~ form_box_list_label.configure("text", "#{File.basename(form_name, ".*").upcase} Box List")
		form_box_list.delete(0, "end")

		form_box_array = build_box_array_rbw(fname)

		#
		# Now insert into the actual box list [TK land].
		#
		form_box_array.each { |box| form_box_list.insert('end', box.num) }

		#
		# Now read in the DataFlow section from the form if there is DataFlow code to read:
		#
		#~ form_dataflow_code_array = read_dataflow_code(fname)

		#
		# Insert the dataflow code [if any] into the dataflow_text region:
		#
		#~ dataflow_text.delete("1.0", "end")
#~ form_dataflow_code_array.each { |line| dataflow_text.insert('end', line) }
		#~ dataflow_text.insert("end", form_dataflow_code_array)
	end
})

read_menu.add('separator')

#
# This reads the .XML file and ...
#
read_menu.add('command', :label=> "XML File [Right; Decimal; Decimal NP Boxes]", :command=> proc {

	fname = get_file_name(cur_dir, "XML")

	unless (fname.empty?)

		cur_dir = File.dirname(fname)
		#~ form_name = fname

		#~ form_box_list_label.configure("text", "#{File.basename(form_name, ".*").upcase} Box List")
		box_list.delete(0, "end")

		xml_box_array = build_box_array_xml(fname)

		#
		# Now insert into the actual box list [TK land].
		#
		xml_box_array.each { |box| box_list.insert('end', box) }
	end
})

main_menu.add('cascade', :menu=>read_menu, :label=>"Read")

profile_menu = TkMenu.new(main_menu, :tearoff=>false)

main_menu.add('command', :label=> "Exit", :command=> proc{exit})

#
# Adding main_menu to the root window.
#
root.menu(main_menu)

Tk.mainloop()
